<template>
    <div class="container">
      <div class="row mt-2">
        <div class="col-sm-3">
          <div class="input-group">
            <input class="form-control form-control-navbar" @keyup.enter="searchit"
            v-model="search" type="search" placeholder="search" aria-label="search">
            <button class="btn btn-primary" @click="searchit">
              <i class="fa fa-search inline"></i>
            </button>
          </div>
        </div>
      </div>

      <div class="row mt-2">
        <div class="col-12">
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">List Event</h3>
            </div>
            <!-- /.card-header -->
            <div class="card-body table-responsive p-0">
              <table class="table table-hover">
                <thead>
                <tr>
                    <th>Icon</th>
                    <th>Nama Event</th>
                    <th>Kategori</th>
                    <th>Awal Pendaftaran</th>
                    <th>Akhir Pendaftaran</th>
                    <th>Tanggal Acara</th>
                    <th>Modify</th>
                </tr>
              </thead>
                <tbody>

                  <tr v-for="t_event in t_event.data" :key="t_event.id_event">
                    <td><img :src="getImgUrl(t_event.poster)" height="120px" width="100px" @click="editModal(t_event)"></td>
                    <td>{{t_event.nama_event}}</td>
                    <td>
                      <div v-if="t_event.type_event == '1'">Career Day</div>
                      <div v-else-if="t_event.type_event == '2'">Seminar</div>
                      <div v-else-if="t_event.type_event == '3'">Workshop</div>
                      <div v-else-if="t_event.type_event == '4'">Bootcamp</div>
                    </td>
                    <td>{{t_event.awal_pendaftaran}}</td>
                    <td>{{t_event.akhir_pendaftaran}}</td>
                    <td>{{t_event.tanggal_acara}}</td>
                    <td>
                      <button class="btn-sm btn-success" @click="editModal(t_event)">Daftar</button>
                    </td>
                  </tr>

              </tbody></table>
            </div>
            <!-- /.card-body -->
            <div class="card-footer">
                <pagination :data="t_event"
                @pagination-change-page="getResults"></pagination>
            </div>
          </div>
          <!-- /.card -->
        </div>
      </div>

      <div class="row mt-2">
        <div class="col-12">
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">History Event Saya</h3>
            </div>
            <!-- /.card-header -->
            <div class="card-body table-responsive p-0">
              <table class="table table-hover">
                <thead>
                <tr>
                    <th>No Tiket</th>
                    <th>Nama Event</th>
                    <th>Tanggal Acara</th>
                    <th>Waktu Register</th>
                    <th>Status Kehadiran</th>
                    <th>Tiket</th>
                </tr>
              </thead>
                <tbody>

                  <tr v-for="v_event_peserta in v_event_peserta.data" :key="v_event_peserta.id_event_peserta">
                    <td>{{v_event_peserta.no_tiket}}</td>
                    <td>{{v_event_peserta.nama_event}}</td>
                    <td>{{v_event_peserta.tanggal_acara}}</td>
                    <td>{{v_event_peserta.waktu_register}}</td>
                    <td>{{v_event_peserta.status_kehadiran}}</td>
                    <td>
                      <router-link :to="`/tiket/${v_event_peserta.id_event_peserta}`">
                        <i class="fas fa-eye"></i>

                      </router-link>
                    </td>
                  </tr>

              </tbody></table>
            </div>
            <!-- /.card-body -->
            <div class="card-footer">
                <pagination :data="v_event_peserta"
                @pagination-change-page="getResults2"></pagination>
            </div>
          </div>
          <!-- /.card -->
        </div>
      </div>

      <!-- Modal -->
      <div class="modal fade" id="addNew" tabindex="-1" role="dialog" aria-labelledby="addNewLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" v-show="editmode" id="addNewLabel">Halaman Konfirmasi</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <form @submit.prevent="editmode ? updateEvent() : createEvent()">
              <div class="modal-body">
                <div class="form-group" hidden>
                  <input v-model="form.id_event" type="text" name="id_event"
                    placeholder="Nama Event" hidden
                    class="form-control" :class="{ 'is-invalid': form.errors.has('id_event') }">
                  <has-error :form="form" field="id_event"></has-error>
                </div>

                <div class="form-group">

                  <p>Apakah anda ingin registrasi event berikut ?</p>
                  <div class="row">
                    <div class="col">

                    </div>
                    <div class="col-md-5">
                      <img :src="getImgUrl(form.poster)" class="img-fluid" alt="Responsive Image">
                    </div>
                    <div class="col">

                    </div>
                  </div>
                  <label>Nama Event :</label>
                  <input v-model="form.nama_event" type="text" name="nama_event"
                    placeholder="Nama Event" readonly
                    class="form-control" :class="{ 'is-invalid': form.errors.has('nama_event') }">
                  <has-error :form="form" field="nama_event"></has-error>
                </div>
                <div class="form-group">
                  <label for="headline">Headline</label>
                  <textarea v-model="form.headline"  name="headline"
                    placeholder="Masukkan Headline"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('headline') }">
                  </textarea>
                  <has-error :form="form" field="headline"></has-error>
                </div>




              </div>
              <div class="modal-footer">
                <button v-show="editmode" type="submit" class="btn btn-success">Ya</button>
                <button type="button" class="btn btn-danger" data-dismiss="modal">Tidak</button>
              </div>
            </form>
        </div>
      </div>
      </div>



    </div>
</template>



<script>
import Form from 'vform'

    export default {
        data() {
          return {
              search: '',
              editmode: false,
              v_event_peserta : {},
              t_event : {},
              form: new Form({
                no_tiket:'',
                poster: '',
                id_event: '',
                id_event_peserta: '',
                nama_event: '',
                type_event: '',
                awal_pendaftaran: '',
                akhir_pendaftaran: '',
                tanggal_acara: '',
                headline: '',
                id_pengenal: '',
                nama_peserta: '',
              })
          }
        },
        methods: {
            getImgUrl(t_event){
              if(t_event!=""){
                return "/img/event/"+t_event;
              } else
              return "/img/event/nothing.png";
            },
            searchit(){
              let query = this.search;
              axios.get('api/findEvent?q='+query)
              .then((data) => {
                this.t_event = data.data
              })
              .catch(() =>{

              })
            },
            getResults(page = 1) {
              axios.get('api/t_event?page=' + page)
                .then(response => {
                  this.t_event = response.data;
                });
            },
            getResults2(page = 1) {
              axios.get('api/historyEventPeserta?page=' + page)
                .then(response => {
                  this.t_event = response.data;
                });
            },
            updateEvent(){
              //  console.log('Editing data');
              this.form.post('api/storePeserta')
              .then(() => {
                swal(
                  'Anda telah berhasil registrasi.',
                  'success'
                )
                $('#addNew').modal('hide')
                this.loadEvents();
              })
              .catch(() => {

              });
            },
            editModal(t_event){
              this.editmode = true;
              this.form.reset();
              $('#addNew').modal('show');
              this.form.fill(t_event);

            },
            loadEvents(){
                axios.get("api/validEvent").then(({data}) => (this.t_event = data));
                axios.get("api/historyEventPeserta").then(({data}) => (this.v_event_peserta = data));
            }

        },
        created() {
            this.loadEvents();
        }
    }
</script>
